// Copyright (C) 2003  Daniel De Graaf
// Functions 30-32
#include "defines.h"

Func RegExpr(FuncArgs) {
	static short RunTest(short*, string, char[9][400], string, short);
	char retbuff[9][400];

	short matchT[300]; //"tokenized" match string
	short x,y;
	
	memset(retbuff,0,3600);
	
	ERR (*args != STR_TAG);
	*args = 0; //2 zero bytes at end helps for expressions like .*^(.*^)
	string testing=GetStrnArg(args);
	*(args+1) = 0xFF;
	ERR (*args != STR_TAG);
	string matchS=GetStrnArg(args);
	for(x=0,y=0;matchS[x];x++,y++) {
		char t=matchS[x];
		if (t == '.') {
			matchT[y] = 0x100;
		} else if (t == '+') {
			matchT[y] = 0x200 + matchT[y-1];
		} else if (t == '*') {
			matchT[--y] += 0x200; //a * adds 200, a + keeps character and adds after
			// .* is 0x300 because . was recorded previously as 0x100
		} else if (t == '^') {
			t = matchS[++x]; //^n, where n is character, is n unless it is '(' ')'
			if (t == '(')
				matchT[y] = 0x400;
			else if (t == ')')
				matchT[y] = 0x500;
			else
				matchT[y] = t;
		} else if (t == '?' && matchT[y-1] == 0x300) {
			matchT[--y] = 0x600; //special case, '.*?' is 1 token
//		} else if (t == '#') {
//			matchT[y] == 0x700		
		} else {
			matchT[y] = t;
	}	}
	matchT[y] = 0;

//	printf("%lx %lx %lx", matchT, testing, retbuff); ngetchx(); //check tokenizing
	if (*args == STR_TAG) {
		string replace = GetStrnArg(args);
		ERR(!RunTest(matchT, testing, retbuff,0,0));
		char tmp[1000], *t;
		*tmp=0;
		while ((t=strchr(replace,'^'))) {
			strncat(tmp,replace,t-replace);
			if (t[1] < '1' || t[1] > '9') {
				short q=strlen(tmp);
				tmp[q] = t[1];
				tmp[q+1] = 0;//not number, move on
			} else {
				strcat(tmp,retbuff[t[1]-'1']);
			}
			replace = t+2; //move replace up past caret
		}	
		strcat(tmp,replace); //the end of the string
		short y=strlen(tmp);
		DefData(y+3);
		*data=0;
		strcpy(data+1,tmp);
		data[y+2]=STR_TAG;
		return d_h;
	} else {
		DefData(1);
		*data = FALSE_TAG + RunTest(matchT, testing, retbuff, 0,0);
		//FALSE_TAG + 1 == TRUE_TAG; RunTest returns 0 or 1
		return d_h;
	}

	//function-in-function
	short RunTest(short* match, string test, char retbuff[9][400], string start, short count) {
		match--;
		BYTE t;
		short x;
		while (*(++match)) {
			switch (*(char*)(match)) {
				case 0:
					if (*match != *(test++)) return 0;
					break;
				case 1: // . matches all
					if (!*(test++)) return 0; // check for end of string
					break;
				case 2:
					t = *match; //chop off 0x200
					while (*(test++) == t); 
					--test;
					break;
				case 3:
//					printf("3:%s",test);
//					if (!*test) //end of string
//						return (!*(match+1)); //1 if end of match, 0 else
					x=0;
					while(test[x++]);
					for(x--; x >= 0; x--)
						if (RunTest(match+1,test+x,retbuff,start,count)) return 1;
					return 0;
				case 4:
					start = test;
					break;
				case 5:
					if (!start) break;
					strcpy(retbuff[count],start);
					retbuff[count++][test - start]=0;
					start=0;
					break;
				case 6:
					for(x=0; test[x-1]; x++)
						if (RunTest(match+1,test+x,retbuff,start,count)) return 1;
					return 0;
//				case 7:
//					return !(*test);
		}	}
		return 1;
}	}

Func HomeExec(FuncArgs) {
	ERR (*args != STR_TAG);
	string z=GetStrnArg(args);
	HomeExecute(z,strlen(z));
	return 0;
}

Func GetSysVal(FuncArgs) {
	short rv=0, k=GetInt(0,3);
	if (k == 0) {
		short v=GetValue(args,0,TIOS_entries);
		DWORD x=(DWORD)(__jmp_tbl[v]);
		DefData(9);
		data[0] = x;
		data[1] = x/0x100;
		data[2] = x/0x10000;
		data[3] = 3;
		data[4] = POSINT_TAG;
		EndData(5);
		return d_h;
	} else if (k == 1) {
		rv = SymFindHome(SYMSTR("main")).folder;
	} else if (k == 2) {
		if (*args == STR_TAG)
			rv = TIOS_EV_getAppID(GetStrnArg(args));
			//I am using AMS 2.00+, so no wrapper needed
		else
			rv = OO_firstACB;
	} else if (k == 3) {
		rv = HeapPtrToHandle((void*)((DWORD)(bottom_estack) & 0xFFFFFFFE));
		ERR (!rv);
	}
	return OneInt(rv);
}
